# coding: utf-8

"""
    Conekta API

    Conekta sdk

    The version of the OpenAPI document: 2.1.0
    Contact: engineering@conekta.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PaymentMethodCardRequest(BaseModel):
    """
    PaymentMethodCardRequest
    """ # noqa: E501
    type: StrictStr = Field(description="Type of payment method")
    cvc: Annotated[str, Field(min_length=3, strict=True, max_length=4)] = Field(description="Card security code")
    exp_month: Annotated[str, Field(min_length=2, strict=True, max_length=2)] = Field(description="Card expiration month")
    exp_year: Annotated[str, Field(min_length=4, strict=True, max_length=4)] = Field(description="Card expiration year")
    name: StrictStr = Field(description="Cardholder name")
    number: StrictStr = Field(description="Card number")
    customer_ip_address: Optional[StrictStr] = Field(default=None, description="Optional field used to capture the customer's IP address for fraud prevention and security monitoring purposes")
    __properties: ClassVar[List[str]] = ["type", "cvc", "exp_month", "exp_year", "name", "number", "customer_ip_address"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentMethodCardRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentMethodCardRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "cvc": obj.get("cvc"),
            "exp_month": obj.get("exp_month"),
            "exp_year": obj.get("exp_year"),
            "name": obj.get("name"),
            "number": obj.get("number"),
            "customer_ip_address": obj.get("customer_ip_address")
        })
        return _obj


